/*
 * Copyright IBM Corp. and others 1991
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 */

/**
 * WARNING!!! GENERATED FILE
 *
 * This class is generated.
 * Do not use the Eclipse "Organize Imports" feature on this class.
 *
 * It can contain user content, but that content must be delimited with the
 * the tags
 * [BEGIN USER IMPORTS]
 * [END USER IMPORTS]
 *
 * or
 *
 * [BEGIN USER CODE]
 * [END USER CODE]
 *
 * These tags are entered as comments.  Characters before [ and after ] are ignored.
 * Lines between the tags are inserted into the newly generated file.
 *
 * IMPORTS are combined and inserted above newly generated imports.  CODE is combined
 * and inserted immediately after the class declaration
 *
 * All lines outside these tags are lost and replaced with newly generated code.
 */
package com.ibm.j9ddr.vm29.pointer.generated;

/*[BEGIN USER IMPORTS]*/
/*[END USER IMPORTS]*/

import com.ibm.j9ddr.CorruptDataException;
import com.ibm.j9ddr.vm29.pointer.*;
import com.ibm.j9ddr.vm29.structure.*;
import com.ibm.j9ddr.vm29.types.*;

/**
 * Structure: _tagADDRESS64Pointer
 *
 * A generated implementation of a VM structure
 *
 * This class contains generated code and MAY contain hand written user code.
 *
 * Hand written user code must be contained at the top of
 * the class file, specifically above
 * the comment line containing WARNING!!! GENERATED CODE
 *
 * ALL code below the GENERATED warning will be replaced with new generated code
 * each time the PointerGenerator utility is run.
 *
 * The generated code will provide getters for all elements in the _tagADDRESS64Pointer
 * structure.  Where possible, meaningful return types are inferred.
 *
 * The user may add methods to provide meaningful return types where only pointers
 * could be automatically inferred.
 */
@com.ibm.j9ddr.GeneratedPointerClass(structureClass=_tagADDRESS64.class)
public class _tagADDRESS64Pointer extends StructurePointer {

	// NULL
	public static final _tagADDRESS64Pointer NULL = new _tagADDRESS64Pointer(0);

/*[BEGIN USER CODE]*/
/*[END USER CODE]*/

	// Do not call this constructor.  Use static method cast instead.
	protected _tagADDRESS64Pointer(long address) {
		super(address);
	}

	public static _tagADDRESS64Pointer cast(AbstractPointer structure) {
		return cast(structure.getAddress());
	}

	public static _tagADDRESS64Pointer cast(UDATA udata) {
		return cast(udata.longValue());
	}

	public static _tagADDRESS64Pointer cast(long address) {
		if (address == 0) {
			return NULL;
		}
		return new _tagADDRESS64Pointer(address);
	}

	public _tagADDRESS64Pointer add(long count) {
		return _tagADDRESS64Pointer.cast(address + (_tagADDRESS64.SIZEOF * count));
	}

	public _tagADDRESS64Pointer add(Scalar count) {
		return add(count.longValue());
	}

	public _tagADDRESS64Pointer addOffset(long offset) {
		return _tagADDRESS64Pointer.cast(address + offset);
	}

	public _tagADDRESS64Pointer addOffset(Scalar offset) {
		return addOffset(offset.longValue());
	}

	public _tagADDRESS64Pointer sub(long count) {
		return _tagADDRESS64Pointer.cast(address - (_tagADDRESS64.SIZEOF * count));
	}

	public _tagADDRESS64Pointer sub(Scalar count) {
		return sub(count.longValue());
	}

	public _tagADDRESS64Pointer subOffset(long offset) {
		return _tagADDRESS64Pointer.cast(address - offset);
	}

	public _tagADDRESS64Pointer subOffset(Scalar offset) {
		return subOffset(offset.longValue());
	}

	public _tagADDRESS64Pointer untag(long mask) {
		return _tagADDRESS64Pointer.cast(address & ~mask);
	}

	public _tagADDRESS64Pointer untag() {
		return untag(UDATA.SIZEOF - 1);
	}

	protected long sizeOfBaseType() {
		return _tagADDRESS64.SIZEOF;
	}

	// Implementation methods

	// ADDRESS_MODE Mode
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_ModeOffset_", declaredType="ADDRESS_MODE")
	public long Mode() throws CorruptDataException {
		if (ADDRESS_MODE.SIZEOF == 1) {
			return getByteAtOffset(_tagADDRESS64._ModeOffset_);
		} else if (ADDRESS_MODE.SIZEOF == 2) {
			return getShortAtOffset(_tagADDRESS64._ModeOffset_);
		} else if (ADDRESS_MODE.SIZEOF == 4) {
			return getIntAtOffset(_tagADDRESS64._ModeOffset_);
		} else if (ADDRESS_MODE.SIZEOF == 8) {
			return getLongAtOffset(_tagADDRESS64._ModeOffset_);
		} else {
			throw new IllegalArgumentException("Unexpected ENUM size in core file");
		}
	}

	// ADDRESS_MODE Mode
	public EnumPointer ModeEA() throws CorruptDataException {
		return EnumPointer.cast(nonNullFieldEA(_tagADDRESS64._ModeOffset_), ADDRESS_MODE.class);
	}

	// U64 Offset
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_OffsetOffset_", declaredType="U64")
	public UDATA Offset() throws CorruptDataException {
		return new U64(getLongAtOffset(_tagADDRESS64._OffsetOffset_));
	}

	// U64 Offset
	public UDATAPointer OffsetEA() throws CorruptDataException {
		return UDATAPointer.cast(nonNullFieldEA(_tagADDRESS64._OffsetOffset_));
	}

	// U16 Segment
	@com.ibm.j9ddr.GeneratedFieldAccessor(offsetFieldName="_SegmentOffset_", declaredType="U16")
	public U16 Segment() throws CorruptDataException {
		return new U16(getShortAtOffset(_tagADDRESS64._SegmentOffset_));
	}

	// U16 Segment
	public U16Pointer SegmentEA() throws CorruptDataException {
		return U16Pointer.cast(nonNullFieldEA(_tagADDRESS64._SegmentOffset_));
	}

}
